searchNodes=[{"ref":"FlakeId.html","title":"FlakeId","type":"module","doc":"Decentralized, k-ordered ID generation service."},{"ref":"FlakeId.html#flake_id?/1","title":"FlakeId.flake_id?/1","type":"function","doc":"Checks that ID is a valid FlakeId Examples iex&gt; FlakeId.flake_id?(&quot;9n2ciuz1wdesFnrGJU&quot;) true iex&gt; FlakeId.flake_id?(&quot;#cofe&quot;) false iex&gt; FlakeId.flake_id?(&quot;pleroma.social&quot;) false"},{"ref":"FlakeId.html#from_integer/1","title":"FlakeId.from_integer/1","type":"function","doc":"Converts an integer to a binary Flake Examples iex&gt; FlakeId.from_integer(28939165907792829150732718047232) &lt;&lt;0, 0, 1, 109, 67, 124, 251, 125, 95, 28, 30, 59, 36, 42, 0, 0&gt;&gt;"},{"ref":"FlakeId.html#from_string/1","title":"FlakeId.from_string/1","type":"function","doc":"Converts a String to a binary Flake Examples iex&gt; FlakeId.from_string(&quot;9n2ciuz1wdesFnrGJU&quot;) &lt;&lt;0, 0, 1, 109, 67, 124, 251, 125, 95, 28, 30, 59, 36, 42, 0, 0&gt;&gt;"},{"ref":"FlakeId.html#get/0","title":"FlakeId.get/0","type":"function","doc":"Generates a string with Flake"},{"ref":"FlakeId.html#to_integer/1","title":"FlakeId.to_integer/1","type":"function","doc":"Converts a binary Flake to an integer Examples iex&gt; FlakeId.to_integer(&lt;&lt;0, 0, 1, 109, 67, 124, 251, 125, 95, 28, 30, 59, 36, 42, 0, 0&gt;&gt;) 28939165907792829150732718047232"},{"ref":"FlakeId.html#to_string/1","title":"FlakeId.to_string/1","type":"function","doc":"Converts a binary Flake to a String Examples iex&gt; FlakeId.to_string(&lt;&lt;0, 0, 1, 109, 67, 124, 251, 125, 95, 28, 30, 59, 36, 42, 0, 0&gt;&gt;) &quot;9n2ciuz1wdesFnrGJU&quot;"},{"ref":"FlakeId.Ecto.CompatType.html","title":"FlakeId.Ecto.CompatType","type":"module","doc":"Provides a compatibility Ecto type for someone wishes to migrate from integer ids to flakes. Schema Example @primary_key {:id, FlakeId.Ecto.CompatType, autogenerate: true} schema &quot;posts&quot; do add :body, :string end"},{"ref":"FlakeId.Ecto.CompatType.html#autogenerate/0","title":"FlakeId.Ecto.CompatType.autogenerate/0","type":"function","doc":"See FlakeId.get/0."},{"ref":"FlakeId.Ecto.CompatType.html#cast/1","title":"FlakeId.Ecto.CompatType.cast/1","type":"function","doc":"Casts the given input to the custom type. This callback is called on external input and can return any type, as long as the dump/1 function is able to convert the returned value into an Ecto native type. There are two situations where this callback is called: When casting values by Ecto.Changeset When passing arguments to Ecto.Query When returning {:error, keyword()}, the returned keyword list will be preserved in the changeset errors, similar to Changeset.add_error/4. Passing a :message key, will override the default message. It is not possible to override the :type key. For {:array, CustomType} or {:map, CustomType} the returned keyword list will be erased and the default error will be shown. Callback implementation for Ecto.Type.cast/1."},{"ref":"FlakeId.Ecto.CompatType.html#dump/1","title":"FlakeId.Ecto.CompatType.dump/1","type":"function","doc":"Dumps the given term into an Ecto native type. This callback is called with any term that was stored in the struct and it needs to validate them and convert it to an Ecto native type. Callback implementation for Ecto.Type.dump/1."},{"ref":"FlakeId.Ecto.CompatType.html#embed_as/1","title":"FlakeId.Ecto.CompatType.embed_as/1","type":"function","doc":"Dictates how the type should be treated inside embeds. By default, the type is sent as itself, without calling dumping to keep the higher level representation. But it can be set to :dump to it is dumped before encoded. Callback implementation for Ecto.Type.embed_as/1."},{"ref":"FlakeId.Ecto.CompatType.html#equal?/2","title":"FlakeId.Ecto.CompatType.equal?/2","type":"function","doc":"Checks if two terms are semantically equal. Callback implementation for Ecto.Type.equal?/2."},{"ref":"FlakeId.Ecto.CompatType.html#load/1","title":"FlakeId.Ecto.CompatType.load/1","type":"function","doc":"Loads the given term into a custom type. This callback is called when loading data from the database and receives an Ecto native type. It can return any type, as long as the dump/1 function is able to convert the returned value back into an Ecto native type. Callback implementation for Ecto.Type.load/1."},{"ref":"FlakeId.Ecto.CompatType.html#type/0","title":"FlakeId.Ecto.CompatType.type/0","type":"function","doc":"Returns the underlying schema type for the custom type. For example, if you want to provide your own date structures, the type function should return :date. Note this function is not required to return Ecto primitive types, the type is only required to be known by the adapter. Callback implementation for Ecto.Type.type/0."},{"ref":"FlakeId.Ecto.Type.html","title":"FlakeId.Ecto.Type","type":"module","doc":"Provides a type for Ecto usage. The underlying data type should be an :uuid. Migration Example create table(:posts, primary_key: false) do add :id, :uuid, primary_key: true add :body, :text end Schema Example @primary_key {:id, FlakeId.Ecto.Type, autogenerate: true} schema &quot;posts&quot; do add :body, :string end"},{"ref":"FlakeId.Ecto.Type.html#autogenerate/0","title":"FlakeId.Ecto.Type.autogenerate/0","type":"function","doc":"See FlakeId.get/0."},{"ref":"FlakeId.Ecto.Type.html#cast/1","title":"FlakeId.Ecto.Type.cast/1","type":"function","doc":"Casts the given input to the custom type. This callback is called on external input and can return any type, as long as the dump/1 function is able to convert the returned value into an Ecto native type. There are two situations where this callback is called: When casting values by Ecto.Changeset When passing arguments to Ecto.Query When returning {:error, keyword()}, the returned keyword list will be preserved in the changeset errors, similar to Changeset.add_error/4. Passing a :message key, will override the default message. It is not possible to override the :type key. For {:array, CustomType} or {:map, CustomType} the returned keyword list will be erased and the default error will be shown. Callback implementation for Ecto.Type.cast/1."},{"ref":"FlakeId.Ecto.Type.html#dump/1","title":"FlakeId.Ecto.Type.dump/1","type":"function","doc":"Dumps the given term into an Ecto native type. This callback is called with any term that was stored in the struct and it needs to validate them and convert it to an Ecto native type. Callback implementation for Ecto.Type.dump/1."},{"ref":"FlakeId.Ecto.Type.html#embed_as/1","title":"FlakeId.Ecto.Type.embed_as/1","type":"function","doc":"Dictates how the type should be treated inside embeds. By default, the type is sent as itself, without calling dumping to keep the higher level representation. But it can be set to :dump to it is dumped before encoded. Callback implementation for Ecto.Type.embed_as/1."},{"ref":"FlakeId.Ecto.Type.html#equal?/2","title":"FlakeId.Ecto.Type.equal?/2","type":"function","doc":"Checks if two terms are semantically equal. Callback implementation for Ecto.Type.equal?/2."},{"ref":"FlakeId.Ecto.Type.html#load/1","title":"FlakeId.Ecto.Type.load/1","type":"function","doc":"Loads the given term into a custom type. This callback is called when loading data from the database and receives an Ecto native type. It can return any type, as long as the dump/1 function is able to convert the returned value back into an Ecto native type. Callback implementation for Ecto.Type.load/1."},{"ref":"FlakeId.Ecto.Type.html#type/0","title":"FlakeId.Ecto.Type.type/0","type":"function","doc":"Returns the underlying schema type for the custom type. For example, if you want to provide your own date structures, the type function should return :date. Note this function is not required to return Ecto primitive types, the type is only required to be known by the adapter. Callback implementation for Ecto.Type.type/0."},{"ref":"readme.html","title":"❄ FlakeId","type":"extras","doc":"❄ FlakeId Decentralized, k-ordered ID generation service"},{"ref":"readme.html#installation","title":"❄ FlakeId - Installation","type":"extras","doc":"Add flake_id to your list of dependencies in mix.exs: def deps do [ {:flake_id, &quot;~&gt; 0.1.0&quot;} ] end"},{"ref":"readme.html#usage","title":"❄ FlakeId - Usage","type":"extras","doc":"iex&gt; FlakeId.get() &quot;9n3171dJZpdD77K3DU&quot; See https://hexdocs.pm/flake_id for the complete documentation. With Ecto It is possible to use FlakeId with Ecto. See FlakeId.Ecto.Type documentation for detailed instructions."},{"ref":"readme.html#prior-art","title":"❄ FlakeId - Prior Art","type":"extras","doc":"flaky, released under the terms of the Truly Free License, Flake, Copyright 2012, Boundary, Apache License, Version 2.0"},{"ref":"readme.html#copyright-and-license","title":"❄ FlakeId - Copyright and License","type":"extras","doc":"Copyright © 2017-2019 Pleroma Authors FlakeId source code is licensed under the GNU LGPLv3 License."}]